/* copyright A. Gleyzes 1999 */
/* toute reproduction ou utilisation commerciale interdite sans le consentement de l'auteur */
/* version du 10/10/99 amlioration bruit numrique*/
/* utilise le timer  1:8*/


#include <pic.h>

__CONFIG(INTRC | UNPROTECT); 	/* rq MCLRE et XDTE sont  0 */

/*******************************************************
*
*	mixer ailerons/profondeur
*
*	p7 : GP0 = entree force  1
*	p6 : GP1 = sortie (A+B)/2
*	p5 : GP2 = sortie LED (rglage neutre) (1 = LED allume)
*	p4 : GP3 = entre servo A ailerons (voie 1)
*	p3 : GP4 = entre servo B profondeur (voie 2)
*	p2 : GP5 = sortie (A-B)/2
*
*	Pendant 10 secondes, la LED est ON et indique l'talonnage 
*	de la dure du neutre. 
*	Aprs calcul de la dure du neutre, le mixer est tabli..
*
*
***********************************************************/

typedef union				/* utilis pour grer les dbordements du timer */
{
	struct 
	{
		unsigned char low;
		unsigned char high;
	} n_cpt ;
	int cpt ;
} compteur;





/* pas d'appels imbriqus ==> on peut passer par le stack en "fastcall" */
fastcall void						
Sorties (compteur consigne1)
{
	if (consigne1.n_cpt.low)
		{
			TMR0 =  (0xFF - consigne1.n_cpt.low) +1;	
			do {		
			} while (TMR0);
		}
	while ( consigne1.n_cpt.high--) 
	{
		TMR0 = 1;
		do {		
		} while (TMR0);
	} 
	GPIO = 0;

}					




/* pas d'appels imbriqus ==> on peut passer par le stack en "fastcall" */
fastcall void						
Entrees (compteur *servo1 , compteur *servo2)
{

	do {					/* attente dbut impulsion */
	} while (GP3 == 0);
	

	TMR0 = 155;				/* reset timer */
	do {					/* attente talon 100*8 usec */
	} while (TMR0);
	
	do {
	} while (GP3 == 1);			/* attente fin impulsion */
	(*servo1).cpt = TMR0 + 100;	/* rajout suite TMR0 */
	
	

			

	do {					/* attente dbut impulsion */
	} while (GP4 == 0);

	TMR0 = 155;				/* reset timer */
	do {					/* attente talon 100*8 usec */
	} while (TMR0);
	
	do {
	} while (GP4 == 1);			/* attente fin impulsion */
	(*servo2).cpt = TMR0 + 100;	/* rajout suite TMR0 */
	
	
}

/* programme principal */

main (void)
{
	unsigned char j;
	unsigned char i;
	
	compteur consigne1;
	compteur consigne2;
	compteur neutreA;
	compteur neutreB;
	compteur duree_ESA;
	compteur duree_ESB;
	compteur temp1;

	
	OPTION = GPWU | GPPU | T0SE | !PSA | 0x02 ; /* wake up disabled
							Pull up disabled
							Internal cycle clock
							High to low source edge
							Prescaler assigned to timer 
							prescaler 1:8 */
	TRIS = 0b011001 ; 			/* GP3, 4 et 0 sont en entree */
	
	GPIO = 4;					/* sortie  0, LED ON*/
	neutreA.cpt = 187;				/* duree neutres 1,5 ms soit 187,5 ticks */
	neutreB.cpt = 187;
	consigne1.cpt = 187;
	consigne2.cpt = 187;
	


	/* calcul des neutres */

	i = 10;					/* boucle 10 secondes filtre le neutre */
	do {						
		j = 50;				/* boucle 50 Hz */
		do { 
			duree_ESA.cpt = 0;
			duree_ESB.cpt = 0;

			Entrees (&duree_ESA, &duree_ESB);
			
								/* calcul et filtre des neutres */
			
			neutreA.cpt = neutreA.cpt + duree_ESA.cpt;
			neutreA.cpt = neutreA.cpt>>1;
			
			neutreB.cpt = neutreB.cpt + duree_ESB.cpt;
			neutreB.cpt = neutreB.cpt>>1;
								
			GPIO = 6;								/* gnration impulsions de sortie */
			Sorties (neutreA);
			GPIO = 0x24;
			Sorties (neutreB);
			GPIO = 4;		/* LED allume */
		} while (--j);

	} while (--i);
	GPIO = 0;					/* tout  zro LED teinte */


/* boucle principale  */


debut :
	duree_ESA.cpt = 0;
	duree_ESB.cpt = 0;



	Entrees (&duree_ESA, &duree_ESB);

/* calcul des consignes si elles sont vraisemblables*/

		
	duree_ESA.cpt = duree_ESA.cpt - neutreA.cpt;
	duree_ESB.cpt = duree_ESB.cpt - neutreB.cpt;
	temp1.cpt = duree_ESA.cpt + duree_ESB.cpt;
	temp1.cpt = temp1.cpt>>1;
	duree_ESA.cpt = duree_ESA.cpt - duree_ESB.cpt;
	duree_ESA.cpt = duree_ESA.cpt>>1;
	
	
	consigne1.cpt =  neutreA.cpt + temp1.cpt;
	consigne2.cpt =  neutreB.cpt + duree_ESA.cpt;


/* appliquer les sorties */
	GPIO = 2;
	Sorties (consigne1);
	GPIO = 0x20;
	Sorties (consigne2);
	goto debut;						/* attente prochaine impulsion */

}

